
package ORF201.gauss_elim;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

import myutil.GridPanel;
import myutil.NumberField;

public class AddVect extends Applet
    implements ActionListener {
    TextField NumVect, LengVect;
    Button AddButt;

    public void init() {
        setLayout(new FlowLayout(FlowLayout.LEFT));
	setSize(500,60);
        setFont(new Font("Courier", Font.BOLD, 12));
        add(new Label("Number of vectors"));
        add(NumVect = new TextField("2",3));
        add(new Label("Length of vectors"));
        add(LengVect = new TextField("2",3));
        add(AddButt = new Button("Go Adding!"));
        AddButt.addActionListener(this);
    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == AddButt) {
            int numvect = Integer.valueOf(NumVect.getText()).intValue();
            int lengvect = Integer.valueOf(LengVect.getText()).intValue();
            AddVectFrame af = new AddVectFrame(numvect,lengvect);
            af.setVisible(true);
        }
    }
}

class AddVectFrame extends Frame implements ActionListener {

    Button button1,button2,button3,button4;
    InputPanel MyInputPanel;

    public AddVectFrame(int num, int length) {
        setLayout(new BorderLayout(10, 10));
	//set the size of the frame according to num and length
        setSize((num + 1)*110+80, length*40+80);

        Panel MyPanel = new Panel();
        MyPanel.setFont(new Font("Helvetica", Font.BOLD, 10));
        button1 = new Button("Generate Random Vectors");
        button1.addActionListener(this);
        MyPanel.add(button1);
        button2 = new Button("Add");
        button2.addActionListener(this);
        MyPanel.add(button2);
        button3 = new Button("Exit");
        button3.addActionListener(this);
        MyPanel.add(button3);
        button4 = new Button("Reset");
        button4.addActionListener(this);
        MyPanel.add(button4);

        add("North",MyPanel);

        MyInputPanel = new InputPanel(num, length);
        add("Center",MyInputPanel);

        // add an AddFrameListener object as a listener
        // for window events generated by this frame
        // (this is so that the frame can be closed through
        //  the window's system menu too, besides the
        //  'exit' button)
        addWindowListener(new AddFrameListener());
    }

    public void actionPerformed(ActionEvent e) {
        // case when the exit button was pressed
        if (e.getSource() == button3) {
            dispose();
        }
        // case when the reset button was pressed
        else if (e.getSource() == button4) {
            MyInputPanel.reset();
        }
        // case when the random generation button was pressed
        else if (e.getSource() == button1) {
            MyInputPanel.genrand();
        }
        else if (e.getSource() == button2) {
            MyInputPanel.add();
        }
    }

    class AddFrameListener extends WindowAdapter {
        public void windowClosing(WindowEvent e) {
            // case when the window is being closed from the
            // window's system menu, instead of through the
            // 'exit' button
            dispose();
        }
    }
}

class InputPanel extends GridPanel {
    int m, n;
    NumberField A[][];
    myCheckbox c[];
    Label B[],plus[], equal;

    public InputPanel(int num, int length) {
        int i, j;

        n = num;
        m = length;

        // instantiate all the components of the input panel
        A = new NumberField[m][n];
        c = new myCheckbox[m];
        plus = new Label[n];
        equal = new Label("=");
        B = new Label[m];
        for (i=0; i<m; i++) {
            c[i] = new myCheckbox(this, i);
            c[i].setState(false);
            for (j=0; j<n; j++) {
                A[i][j] = new NumberField("0.0", 5);
            }
            B[i] = new Label("0.0");
        }
	for (j=0; j<n; j++) {
	    plus[j] = new Label("+");
	}

        // add all the components of the input panel into
        // the underlying grid panel
        // (note that when one adds a component to a GL
        //  grid panel, one can specify only the coords
        //  [x, y] of the position of the component, or
        //  one can add the width and the height [w, h]
        //  too; furthermore, there are no preset limits
        //  on the dimensions of the grid, they are
        //  dynamically adjusted as the components are
        //  added)
        for (i=0; i<m; i++) {
            add(c[i], 0, i+2);
            for (j=0; j<(n-1); j++) {
                add(A[i][j], 3*j+1, i+2);
		if (i==m/2)
		    add(plus[j], 3*j+2, i+2);
            }
            add(A[i][n-1], 3*n-2, i+2);
	    if (i==m/2)
		add(equal, 3*n-1, i+2);
            add(B[i], 3*n+1, i+2);
        }
    }


    public void genrand() {
        int i, j;
        double value;

        for (i=0; i<m; i++) {
            for (j=0; j<n; j++) {
                if (Math.random() < 0.9) {
                    value = (int) (10*Math.random())-5;
                    value += (int) (5*Math.random())-2;
                    value += (int) (-3*Math.random())+6;
                }
                else value = 0;
                A[i][j].toNumberField(value);
            }
        }
    }

    public void reset() {
        int i, j;

        for (i=0; i<m; i++) {
            for (j=0; j<n; j++) A[i][j].toNumberField(0);
            B[i].setText("0.0");
        }
    }

    void add() {
	int i,j;
	for(i=0;i<m;i++){
	    double sumrow=0;
	    for(j=0;j<n;j++){
		sumrow+=A[i][j].fromNumberField();
	    }
	    B[i].setText(""+sumrow);
	}
    }

    void addrow(int row){
	int i,j;
	double sumrow=0;
	for(j=0;j<n;j++){
	    sumrow+=A[row][j].fromNumberField();
	}
	B[row].setText(""+sumrow);
    }

    void resetrow(int row){
	B[row].setText("0.0");
    }
}

class myCheckbox extends Checkbox implements ItemListener {
    InputPanel ip;// the container which this box belongs to
    int row;      // the index of the corresponding 'row'

    public myCheckbox(InputPanel p, int r) {
        // store this instance data
        ip = p;
        row = r;
        // add this component as a listener to itself
        addItemListener(this);
    }

    public void itemStateChanged(ItemEvent e) {
        // case when the box is being checked on
        if (getState() == true) {
            ip.addrow(row);
        }
        // case when the box is being checked off
        else {
            ip.resetrow(row);
        }
    }
}






