package ge.gauss_elim;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

import myutil.GridPanel;
import myutil.NumberField;

public class ge extends Applet
    implements ActionListener
    {
		//page setup for the first html file
    	TextField rows, cols;
    	Button GoElimButt;

    	public void init()
    	{
     	   setLayout(new FlowLayout(FlowLayout.LEFT));
     	   setFont(new Font("Courier", Font.BOLD, 12));
     	   add(new Label("ROWS"));
     	   add(rows = new TextField("4",6));
     	   add(new Label("COLUMNS"));
    	   add(cols = new TextField("4",6));
     	   add(GoElimButt = new Button("START"));
   	       GoElimButt.addActionListener(this);
		}




    public void actionPerformed(ActionEvent e)//it will calculate for the size of matrix in line 368
    {
		if (e.getSource() == GoElimButt) //if click on the "Go!" button,
		{
			int m = Integer.valueOf(rows.getText()).intValue();
			int n = Integer.valueOf(cols.getText()).intValue();
			PivotFrame pf = new PivotFrame(m,n); //creates pivot frame from class in 46
			pf.setVisible(true); //set the variable "visible" true

		}

    }
}

class PivotFrame extends Frame implements ActionListener
{

    Button b1, b2, b3, b4, b5; //button setup
    InputPanel ip;

    public PivotFrame(int m, int n)
    {

               setLayout(new BorderLayout(10,10));
               setSize((m+1)*110+150, n*40+150);


               Panel p1 = new Panel();
			   p1.setFont(new Font("Courier", Font.BOLD, 12));
		//button 1: generates a random problem
			   b1 = new Button("GENERATE RANDOM #");
			   b1.addActionListener(this);
			   p1.add(b1);
		//button 2 connects to reseting the frames
			   b2 = new Button("[RESET]");
			   b2.addActionListener(this);
			   p1.add(b2);
		//button 3 exits the program
			   b3 = new Button("[EXIT]");
			   b3.addActionListener(this);
			   p1.add(b3);
		//button 4 changes the entries to decimal form
			   b4 = new Button("DECIMAL FORM");
			   b4.addActionListener(this);
			   p1.add(b4);
		//button 5 changes the entries to fraction form
			   b5 = new Button("FRACTION FORM");
			   b5.addActionListener(this);
			   p1.add(b5);

			   add("South",p1);   //adds 5 buttons on top of screen

			   ip = new InputPanel(m, n);
			   ip.setFont(new Font("Courier", Font.BOLD, 14));
			   add("Center",ip);
			   addWindowListener(new AddFrameListener());
    }

    public void actionPerformed(ActionEvent e)
    {
         if (e.getSource() == b3)
         {
			 dispose(); //exit if click on the 'EXIT' button
		 }
		 else if (e.getSource() == b2)
		 {
			 ip.reset(); //reset if click on the 'RESET' button
		 }
		 else if (e.getSource() == b1)
		 {
			 ip.genrand();//Generate random #s if click on the 'Generate random #' button
		 }
		 else if (e.getSource() == b4)
		 {
			 ip.setFmt("Decimal");//display with Decimal set if click on the 'DECIMAL FORM' button
		 }
		 else if (e.getSource() == b5)
		 {
			 ip.setFmt("Fraction");//display with Fraction set if click on the 'FRACTION FORM' button
		 }
	 }

	 class AddFrameListener extends WindowAdapter
	 {
		 public void windowClosing(WindowEvent e)
		 {
			 dispose();
		 }
	 }


}

class InputPanel extends GridPanel
{
	//int n;            // # of check boxes
	//int curRow=-1, prevRow=-1;  // the last 2 checked boxes

    Label cHeading, pHeading;
    int m, n;
    NumberField A[][], B[];			//A=coefficients, B=results
    myCheckbox c[];				    //checkboxes
    Label plus[][], equal[];
    String xlabel[];
	myButton x[][];

    public InputPanel(int rows, int cols)
    {
       int i, j;

       m = rows;
       n = cols;

       cHeading = new Label("SWAP");
       pHeading = new Label("GAUSSIAN ELIMINATION MATRIX - Major Assignment");
       A = new NumberField[m][n+1];
       c = new myCheckbox[m];
       plus = new Label[m][n];
       equal = new Label[m];
       //B = new NumberField[m+1];
       xlabel = new String[n];
       x = new myButton[m][n];

 	   for (j=0; j<n; j++)
	   {
		   xlabel[j] = "x"+j;
	   }

	   for (i=0; i<m; i++)
       {
		   c[i] = new myCheckbox(this, i);
		   c[i].setState(false);
		   for (j=0; j<=n; j++)
		   {
			   A[i][j] = new NumberField("0.0", 5);
			   if (i==j)
			   {
				   A[i][j].setBackground(Color.yellow);
			   }
			   if (j!=n)
			   {
			   		x[i][j] = new myButton("X"+j+1, this, i, j);
			   		plus[i][j] = new Label("+");
			   }

		   }

		   equal[i] = new Label("=");
		   A[i][n] = new NumberField("0.0",5);
		   //B[i] = new NumberField("0.0",5);
	   }

	   add(cHeading, 0, 0, 1, 1);
	   add(pHeading, 3, 0, 2*n+2, 1);
	   for (i=0; i<m; i++)
	   {
		   add(c[i], 0, i+2);
		   for (j=0; j<n; j++)
		   {
			   add(A[i][j], 3*j+1, i+2);
			   add(x[i][j], 3*j+2, i+2);
			   if (j!=(n-1)) add(plus[i][j], 3*j+3, i+2);
		   }
		   add(equal[i], 3*n+3, i+2);
		   add(A[i][n], 3*n+6, i+2);
	   }

    }

    void diag(int row, double factor)
    {
		int j;
			for (j=0; j<n; j++)
			{
				A[row][j].toNumberField(A[row][j].fromNumberField() / factor);
			}
    }

    void nondiag(int row, int col, double factor)
    {
		int j;
		if (row<col)
		{
			for (j=0; j<=n; j++)
			{
				if (j!=col)
				{
					A[row][j].toNumberField(A[row][j].fromNumberField()-A[row+1][col].fromNumberField()/A[row+1][j].fromNumberField()*A[row][col].fromNumberField());
				}
			}
			A[row][col].toNumberField(0);
		}

		else if (row>col)
		{
			for (j=0; j<n; j++)
			{
				if (j!=col)
				{
					A[row][j].toNumberField(A[row][j].fromNumberField()-A[row-1][col].fromNumberField()/A[row-1][j].fromNumberField()*A[row][col].fromNumberField());
				}
			}
			A[row][col].toNumberField(0);
		}
    }

    public void swap_rows(int first, int second)
	{
		int j;
		for (j=0; j<n; j++)
		{
			double firstValue = A[first][j].fromNumberField();
			double secondValue = A[second][j].fromNumberField();
			A[first][j].toNumberField(secondValue);
			A[second][j].toNumberField(firstValue);
		}
    }


    public void genrand()
    {
		int i, j;
		double value;

		for (i=0; i<m; i++)
		{
			for (j=0; j<=n; j++)
			{
				if (Math.random()<0.9)
				{
					value =  (int) (10*Math.random())-5;
					value += (int) (5*Math.random())-2;
					value += (int) (-3*Math.random())+6;
				}
				else value = 0;
				A[i][j].toNumberField(value);
			}
		}
	}

    public void reset()
    {
		int i, j;

		for (i=0; i<m; i++)
		{
			for (j=0; j<=n; j++)
			{
				A[i][j].toNumberField(0);
			}
		}
	}


    void setFmt(String format)
    {
		int i, j;
		for (i=0; i<m; i++)
		{
			for (j=0; j<=n; j++)
			{
				A[i][j].setFormat(format);
				A[i][j].toNumberField(A[i][j].fromNumberField());
			}
		}


    }

    void addSwapMark(int selRow)
    {
		//if (prevRow >= 0) cb[prevRow].setState(false);
		//prevRow = curRow;
		//curRow = selRow;
        //resetLabels(prevRow, curRow);

    }

    void removeSwapMark()
    {


    }
}

class myCheckbox extends Checkbox implements ItemListener {
    InputPanel ip;// the container which this box belongs to
    int row;      // the index of the corresponding 'row'

    public myCheckbox(InputPanel p, int r)
    {
        // store this instance data
        ip = p;
        row = r;
        // add this component as a listener to itself
        addItemListener(this);
    }

    public void itemStateChanged(ItemEvent e)
    {			// case when the box is being checked on
        if (getState() == true) {
            /* add a swap mark for this row and possibly
              do the swap if it is time for that */
        }
        // case when the box is being checked off
        else {
            /* remove the swap mark from the row */
        }
    }
}

class myButton extends Button implements ActionListener {
    InputPanel ip;// the container which this button belongs to
    int row, col; // the indices of the corresponding 'cell'

    public myButton(String label, InputPanel p, int r, int c) {
        super(label);
        // store this instance data
        ip  = p;
        row = r;
        col = c;
        // add this component as a listener to itself
        addActionListener(this);
    }

    public void actionPerformed(ActionEvent e)//calculation to make proper size of matrix
    {
		if (e.getSource() == ip.x[row][col] && row==col) //in case that row num is same as col num
		{
			ip.diag(row, ip.A[row][col].fromNumberField());
		}

		else if (e.getSource() == ip.x[row][col])//otherwise
		{
			ip.nondiag(row, col, ip.A[row][col].fromNumberField());
		}

    }
}

