package myutil;

class ObjLink
{
    String key;
    Object obj;
    ObjLink next;

    public ObjLink(String key, Object obj)
    {
	this.key = key;
	this.obj = obj;
    }
}

public class HashTable
{
    int n;
    ObjLink[] objLinkArray;
    int theta;

    public HashTable(int n)
    {
	this.n = n;
	objLinkArray = new ObjLink[n];
	theta =  (int)(0.3874576628*n);

	for (int j=0; j<n; j++) {
	    objLinkArray[j] = null;
	}
    }

    public void add(String key, Object obj)
    {
	Object o;
	ObjLink ol;
	int hashval;

	o = lookUp(key);
	if (o == null) {
	    ol = new ObjLink(key, obj);
	    hashval = hash(key);
	    ol.next = objLinkArray[hashval];
	    objLinkArray[hashval] = ol;
	}
    }

    public Object lookUp(String name)
    {
	ObjLink ol;

	for (ol = objLinkArray[hash(name)]; ol != null; ol = ol.next) {
	    if (name.equals(ol.key)) {
		return ol.obj;	// found it
	    }
	}
	return null;		// not found
    }

    int hash(String s)
    {
        int hashval;

	int len = s.length();
	byte[] b = new byte[len];
	s.getBytes(0, len, b, 0);

	hashval = 0;
	for (int j=0; j<len; j++) {
	    hashval = b[j] + theta*hashval;
	}
	if (hashval < 0) {hashval = -hashval;}
        return hashval % n;
    }

    public void print(int k)
    {
	ObjLink ol;
	if (k > n) {k = n;}
	System.out.println(this+": \n");
	for (int j=0; j<k; j++) {
	    System.out.print("  "+j+": --> ");
	    for (ol = objLinkArray[j]; ol != null; ol = ol.next) {
		System.out.print(ol.key+", "+ol.obj+", --> ");
	    }
	    System.out.println("");
	}
    }

    public void print()
    {
	print(n);
    }
}
